<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8"/>
<title>Inscription</title>
<link rel="stylesheet" type="text/css" href="stylesheet.css"/>

<script type="text/javascript" src="md5.js"></script>

<script type="text/javascript">
// GLOBALS
var url = window.location.href;
var host = window.location.origin;
let pathname = window.location.pathname;
var path = pathname.substring(0, pathname.lastIndexOf('/')+1);
var script = 'server.php';
var server = host + path + script;


// FETCH
// envoie data à l'url et retourne la réponse 
async function post_data(url, data) {
	//console.log('fetching from "'+url+'"...');
	const response = await fetch(url, {
		method: 'POST',
		mode: 'cors',
		cache: 'no-cache',
		credentials: 'omit',
		redirect: 'follow',
		referrer: 'no-referrer',
		body: JSON.stringify(data)
	});
	//console.log('fetched! parsing...');
	/*let text = await response.text();
	console.log(text);*/
	let res = await response.json(); // JSON to js object
	//console.log('parsing is done!');
	return res;
}


// COOKIES
function setCookie(name, value, days = 1) {
	let expires = "";
	if(days) {
		var date = new Date();
		date.setTime(date.getTime() + (days*24*60*60*1000));
		expires = "; expires=" + date.toUTCString();
	}
	document.cookie = name + "=" + (value || "")  + expires + "; path=/";
}

function getCookie(name) {
	let nameEQ = name + "=";
	let ca = document.cookie.split(';');
	for(let i=0; i<ca.length; i++) {
		let c = ca[i];
		while(c.charAt(0) == ' '){
			c = c.substring(1, c.length);
		}
		if(c.indexOf(nameEQ) == 0) {
			return c.substring(nameEQ.length, c.length);
		}
	}
	return null;
}

function eraseCookie(name) {   
	document.cookie = name + '=; Max-Age=-99999999;';
}


// PERMISSIONS
// déjà connecté
if(getCookie('user_id') !== null) {
	alert('Vous êtes déjà inscrit !');
	window.location.replace('evenements.html');
}


// REQUETE
// inscription d'un utilisateur sur le site
function inscription(){
	let pseudo = document.getElementById('login').value;
	let mdp = document.getElementById('pass').value;
	let role = document.querySelector('input[name="role"]:checked').value;
	let contact = document.getElementById('contact').value;

	if(contact === undefined){
		contact = null;
	}

	let query = {
		'type': 'call',
		'procedure': 'inscription',
		'parameters': {
			'pseudonyme': pseudo, //CryptoJS.MD5(mdp);
			'mot_de_passe': mdp,
			'role': role,
			'contact': contact
		}
	};

	post_data(server, query)
	.then(res => {
		if(res['error']) {
			alert(res['error']);
			return;
		}

		let result = res['result'][0];

		for(let cookie in result) {
			eraseCookie(cookie);
			setCookie(cookie, result[cookie]);
		}

		alert('Inscription réussie !');
		window.location.replace('evenements.html');
	});
}
</script>
</head>

<body>
<div id="padding"></div>
	<h3>Inscription</h3>
	<form method="POST" action="javascript:inscription();">
		<p>	Pseudonyme : </p>
		<input type="text" id="login" required>

		<p> Mot de passe : </p>
		<input type="password" id="pass" required>
		<br>

		<p> Role : </p>
		<label><input type="radio" name="role" value="utilisateur" checked> Utilisateur</label>
		<label><input type="radio" name="role" value="contributeur"> Contributeur</label>
		<br>

		<p> Contact : </p>
		<input type="text" id="contact">
		<br>

		<input type="submit" value="S'inscrire">
	</form>
</body>

<script type="text/javascript">
// ÉLÉMENTS DYNAMIQUES
// navbar
let navbar = document.createElement('div');
navbar.id = 'navbar';
navbar.className = 'navbar_elems';

let accueil = document.createElement('a');
let evenement = document.createElement('a');
let contribution = document.createElement('a');

accueil.className = evenement.className = contribution.className = navbar.className;

accueil.id = 'nb0';
evenement.id = 'nb1';
contribution.id = 'nb2';

accueil.href = './index.html';
evenement.href = './evenements.html';
contribution.href = './contribution.html';

accueil.innerHTML = 'Accueil';
evenement.innerHTML = 'Évènement';
contribution.innerHTML = 'Soumettre un évènement';

navbar.appendChild(accueil);
navbar.appendChild(evenement);
navbar.appendChild(contribution);

if(getCookie('user_id') != null) {
	let profil = document.createElement('a');
	profil.className = navbar.className;
	profil.id = 'nb3';
	profil.href = './profil.html';
	profil.innerHTML = 'Connecté en tant que ' + getCookie('pseudo');
	navbar.appendChild(profil);
	
	let disconnect = document.createElement('a');
	disconnect.className = navbar.className;
	disconnect.id = 'nb4';
	disconnect.innerHTML = 'Déconnexion';
	disconnect.onclick = function() {
		eraseCookie('user_id');
		eraseCookie('pseudo');
		eraseCookie('role');
		eraseCookie('contact');
		window.location.reload(true);
	}
	navbar.appendChild(disconnect);
}
else {
	let connect = document.createElement('a');
	connect.className = navbar.className;
	connect.id = 'nb3';
	connect.href = './connexion.html';
	connect.innerHTML = 'Connexion';
	navbar.appendChild(connect);

	let sign_in = document.createElement('a');
	sign_in.className = navbar.className;
	sign_in.id = 'nb4';
	sign_in.href = './inscription.html';
	sign_in.innerHTML = 'S\'inscrire';
	navbar.appendChild(sign_in);
}

document.body.insertBefore(navbar, document.body.firstChild);


// le champs contact est optionnel pour un utilisateur
let utilisateur = document.querySelector('input[value="utilisateur"');
utilisateur.addEventListener('change', function() {
	let contact = document.getElementById('contact');
	contact.required = false;
});

// obligatoire pour un contributeur
let contributeur = document.querySelector('input[value="contributeur"');
contributeur.addEventListener('change', function() {
	let contact = document.getElementById('contact');
	contact.required = true;
});
</script>
</html>